diff -r 3f1e7d35d0ab -r 821e8eadeaff src/datatypes.h
--- a/src/datatypes.h	Tue May 14 17:07:59 2013 -0700
+++ b/src/datatypes.h	Sun Oct 27 22:49:29 2013 -0700
@@ -1,7 +1,37 @@
+/*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
+ * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
+ *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
+ * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
+ *
+ * All Rights Reserved
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are
+ * met:
+ * 1. Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
+ * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+ * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
+ * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
+ * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
 #ifndef DATATYPES_H_
 #define DATATYPES_H_
 
-#include <stdio.h> 
+#include <stdio.h>
 
 /*Struct defined in spec*/
 
@@ -12,233 +42,241 @@
 *
 * This header file defines structures defined by the spec,
 * main program data structure, and all messages structures
- */
+*/
 
 
 /**
 * \brief The TimeInterval type represents time intervals
- */
+*/
 typedef struct {
-	Integer64 scaledNanoseconds;
+  Integer64 scaledNanoseconds;
 } TimeInterval;
 
 /**
 * \brief The Timestamp type represents a positive time with respect to the epoch
- */
+*/
 typedef struct  {
-	UInteger48 secondsField;
-	UInteger32 nanosecondsField;
+  UInteger48 secondsField;
+  UInteger32 nanosecondsField;
 } Timestamp;
 
 /**
 * \brief The ClockIdentity type identifies a clock
- */
+*/
 typedef Octet ClockIdentity[CLOCK_IDENTITY_LENGTH];
 
 /**
 * \brief The PortIdentity identifies a PTP port.
- */
+*/
 typedef struct {
-	ClockIdentity clockIdentity;
-	UInteger16 portNumber;
+  ClockIdentity clockIdentity;
+  UInteger16 portNumber;
 } PortIdentity;
 
 /**
 * \brief The PortAdress type represents the protocol address of a PTP port
- */
+*/
 typedef struct {
-	Enumeration16 networkProtocol;
-	UInteger16 adressLength;
-	Octet* adressField;
+  Enumeration16 networkProtocol;
+  UInteger16 adressLength;
+  Octet* adressField;
 } PortAdress;
 
 /**
 * \brief The ClockQuality represents the quality of a clock
- */
+*/
 typedef struct {
-	UInteger8 clockClass;
-	Enumeration8 clockAccuracy;
-	UInteger16 offsetScaledLogVariance;
+  UInteger8 clockClass;
+  Enumeration8 clockAccuracy;
+  UInteger16 offsetScaledLogVariance;
 } ClockQuality;
 
 /**
 * \brief The TLV type represents TLV extension fields
- */
+*/
 typedef struct {
-	Enumeration16 tlvType;
-	UInteger16 lengthField;
-	Octet* valueField;
+  Enumeration16 tlvType;
+  UInteger16 lengthField;
+  Octet* valueField;
 } TLV;
 
 /**
 * \brief The PTPText data type is used to represent textual material in PTP messages
- */
+*/
 typedef struct {
-	UInteger8 lengthField;
-	Octet* textField;
+  UInteger8 lengthField;
+  Octet* textField;
 } PTPText;
 
 /**
 * \brief The FaultRecord type is used to construct fault logs
- */
+*/
 typedef struct {
-	UInteger16 faultRecordLength;
-	Timestamp faultTime;
-	Enumeration8 severityCode;
-	PTPText faultName;
-	PTPText faultValue;
-	PTPText faultDescription;
+  UInteger16 faultRecordLength;
+  Timestamp faultTime;
+  Enumeration8 severityCode;
+  PTPText faultName;
+  PTPText faultValue;
+  PTPText faultDescription;
 } FaultRecord;
 
 
 /**
 * \brief The common header for all PTP messages (Table 18 of the spec)
- */
+*/
 /* Message header */
 typedef struct {
-	Nibble transportSpecific;
-	Enumeration4 messageType;
-	UInteger4 versionPTP;
-	UInteger16 messageLength;
-	UInteger8 domainNumber;
-	Octet flagField[2];
-	Integer64 correctionfield;
-	PortIdentity sourcePortIdentity;
-	UInteger16 sequenceId;
-	UInteger8 controlField;
-	Integer8 logMessageInterval;
+  Nibble transportSpecific;
+  Enumeration4 messageType;
+  UInteger4 versionPTP;
+  UInteger16 messageLength;
+  UInteger8 domainNumber;
+  Octet flagField[2];
+  Integer64 correctionfield;
+  PortIdentity sourcePortIdentity;
+  UInteger16 sequenceId;
+  UInteger8 controlField;
+  Integer8 logMessageInterval;
 } MsgHeader;
 
 
 /**
 * \brief Announce message fields (Table 25 of the spec)
- */
+*/
 /*Announce Message */
 typedef struct {
-	Timestamp originTimestamp;
-	Integer16 currentUtcOffset;
-	UInteger8 grandmasterPriority1;
-	ClockQuality grandmasterClockQuality;
-	UInteger8 grandmasterPriority2;
-	ClockIdentity grandmasterIdentity;
-	UInteger16 stepsRemoved;
-	Enumeration8 timeSource;
+  Timestamp originTimestamp;
+  Integer16 currentUtcOffset;
+  UInteger8 grandmasterPriority1;
+  ClockQuality grandmasterClockQuality;
+  UInteger8 grandmasterPriority2;
+  ClockIdentity grandmasterIdentity;
+  UInteger16 stepsRemoved;
+  Enumeration8 timeSource;
 }MsgAnnounce;
 
 
 /**
 * \brief Sync message fields (Table 26 of the spec)
- */
+*/
 /*Sync Message */
 typedef struct {
-	Timestamp originTimestamp;
+  Timestamp originTimestamp;
 }MsgSync;
 
 /**
 * \brief DelayReq message fields (Table 26 of the spec)
- */
+*/
 /*DelayReq Message */
 typedef struct {
-	Timestamp originTimestamp;
+  Timestamp originTimestamp;
 }MsgDelayReq;
 
 /**
 * \brief DelayResp message fields (Table 30 of the spec)
- */
+*/
 /*delayResp Message*/
 typedef struct {
-	Timestamp receiveTimestamp;
-	PortIdentity requestingPortIdentity;
+  Timestamp receiveTimestamp;
+  PortIdentity requestingPortIdentity;
 }MsgDelayResp;
 
 /**
 * \brief FollowUp message fields (Table 27 of the spec)
- */
+*/
 /*Follow-up Message*/
 typedef struct {
-	Timestamp preciseOriginTimestamp;
+  Timestamp preciseOriginTimestamp;
 }MsgFollowUp;
 
 /**
 * \brief PDelayReq message fields (Table 29 of the spec)
- */
+*/
 /*PdelayReq Message*/
 typedef struct {
-	Timestamp originTimestamp;
+  Timestamp originTimestamp;
 }MsgPDelayReq;
 
 /**
 * \brief PDelayResp message fields (Table 30 of the spec)
- */
+*/
 /*PdelayResp Message*/
 typedef struct {
-	Timestamp requestReceiptTimestamp;
-	PortIdentity requestingPortIdentity;
+  Timestamp requestReceiptTimestamp;
+  PortIdentity requestingPortIdentity;
 }MsgPDelayResp;
 
 /**
 * \brief PDelayRespFollowUp message fields (Table 31 of the spec)
- */
+*/
 /*PdelayRespFollowUp Message*/
 typedef struct {
-	Timestamp responseOriginTimestamp;
-	PortIdentity requestingPortIdentity;
+  Timestamp responseOriginTimestamp;
+  PortIdentity requestingPortIdentity;
 }MsgPDelayRespFollowUp;
 
 /**
 * \brief Signaling message fields (Table 33 of the spec)
- */
+*/
 /*Signaling Message*/
 typedef struct {
-	PortIdentity targetPortIdentity;
-	char* tlv;
+  PortIdentity targetPortIdentity;
+  char* tlv;
 }MsgSignaling;
 
 /**
 * \brief Management message fields (Table 37 of the spec)
- */
+*/
 /*management Message*/
 typedef struct {
-	PortIdentity targetPortIdentity;
-	UInteger8 startingBoundaryHops;
-	UInteger8 boundaryHops;
-	Enumeration4 actionField;
-	char* tlv;
+  PortIdentity targetPortIdentity;
+  UInteger8 startingBoundaryHops;
+  UInteger8 boundaryHops;
+  Enumeration4 actionField;
+  char* tlv;
 }MsgManagement;
 
 
 
 /**
-* \brief Time structure to handle Linux time information
- */
-typedef struct {
-	Integer32 seconds;
-	Integer32 nanoseconds;
-} TimeInternal;
-
-/**
 * \brief Structure used as a timer
- */
+*/
 typedef struct {
-	Integer32 interval;
-	Integer32 left;
-	Boolean expire;
+  Integer32  interval;
+  Integer32  left;
+  Boolean expire;
 } IntervalTimer;
 
 
 /**
 * \brief ForeignMasterRecord is used to manage foreign masters
+*/
+typedef struct
+{
+  PortIdentity foreignMasterPortIdentity;
+  UInteger16 foreignMasterAnnounceMessages;
+
+  //This one is not in the spec
+  MsgAnnounce  announce;
+  MsgHeader    header;
+} ForeignMasterRecord;
+
+/** 
+ * \brief Structure used to collect statistics
  */
 typedef struct
 {
-	PortIdentity foreignMasterPortIdentity;
-	UInteger16 foreignMasterAnnounceMessages;
+  UInteger32  ts_sync_failures;
+} Statistics;
 
-	//This one is not in the spec
-	MsgAnnounce  announce;
-	MsgHeader    header;
-} ForeignMasterRecord;
-
+/**
+*  \brief Timestamp method in use
+*/
+typedef enum {
+  TS_METHOD_SYSTEM,
+  TS_METHOD_SO_TIMESTAMPING,
+  TS_METHOD_DRIVER_IOCTL
+} TsMethod;
 
 /**
  * \struct PtpClock
@@ -246,241 +284,329 @@
  */
 /* main program data structure */
 typedef struct {
-	/* Default data set */
+  /* Default data set */
 
-	/*Static members*/
-	Boolean twoStepFlag;
-	ClockIdentity clockIdentity;
-	UInteger16 numberPorts;
+  /*Static members*/
+  Boolean twoStepFlag;
+  ClockIdentity clockIdentity;
+  UInteger16 numberPorts;
 
-	/*Dynamic members*/
-	ClockQuality clockQuality;
+  /*Dynamic members*/
+  ClockQuality clockQuality;
 
-	/*Configurable members*/
-	UInteger8 priority1;
-	UInteger8 priority2;
-	UInteger8 domainNumber;
-	Boolean slaveOnly;
+  /*Configurable members*/
+  UInteger8 priority1;
+  UInteger8 priority2;
+  UInteger8 domainNumber;
+  Boolean slaveOnly;
 
 
-	/* Current data set */
+  /* Current data set */
 
-	/*Dynamic members*/
-	UInteger16 stepsRemoved;
-	TimeInternal offsetFromMaster;
-	TimeInternal meanPathDelay;
+  /*Dynamic members*/
+  UInteger16 stepsRemoved;
+  TimeInternal offsetFromMaster;
+  TimeInternal meanPathDelay;
 
 
-	/* Parent data set */
+  /* Parent data set */
 
-	/*Dynamic members*/
-	PortIdentity parentPortIdentity;
-	Boolean parentStats;
-	UInteger16 observedParentOffsetScaledLogVariance;
-	Integer32 observedParentClockPhaseChangeRate;
-	ClockIdentity grandmasterIdentity;
-	ClockQuality grandmasterClockQuality;
-	UInteger8 grandmasterPriority1;
-	UInteger8 grandmasterPriority2;
+  /*Dynamic members*/
+  PortIdentity parentPortIdentity;
+  Boolean parentStats;
+  UInteger16 observedParentOffsetScaledLogVariance;
+  Integer32 observedParentClockPhaseChangeRate;
+  ClockIdentity grandmasterIdentity;
+  ClockQuality grandmasterClockQuality;
+  UInteger8 grandmasterPriority1;
+  UInteger8 grandmasterPriority2;
 
-	/* Global time properties data set */
+  /* Global time properties data set */
 
-	/*Dynamic members*/
-	Integer16 currentUtcOffset;
-	Boolean currentUtcOffsetValid;
-	Boolean leap59;
-	Boolean leap61;
-	Boolean timeTraceable;
-	Boolean frequencyTraceable;
-	Boolean ptpTimescale;
-	Enumeration8 timeSource;
+  /*Dynamic members*/
+  Integer16 currentUtcOffset;
+  Boolean currentUtcOffsetValid;
+  Boolean leap59;
+  Boolean leap61;
+  Boolean timeTraceable;
+  Boolean frequencyTraceable;
+  Boolean ptpTimescale;
+  Boolean leapSecondInProgress;
+  Boolean leapSecondPending;
+  Enumeration8 timeSource;
 
-	/* Port configuration data set */
+  /* Port configuration data set */
 
-	/*Static members*/
-	PortIdentity portIdentity;
+  /*Static members*/
+  PortIdentity portIdentity;
 
-	/*Dynamic members*/
-	Enumeration8 portState;
-	Integer8 logMinDelayReqInterval;
-	TimeInternal peerMeanPathDelay;
- 
-	/*Configurable members*/
-	Integer8 logAnnounceInterval;
-	UInteger8 announceReceiptTimeout;
-	Integer8 logSyncInterval;
-	Enumeration8 delayMechanism;
-	Integer8 logMinPdelayReqInterval;
-	UInteger4 versionNumber;
+  /*Dynamic members*/
+  Enumeration8 portState;
+  LongDouble minDelayReqInterval;
+  Integer8 logMinDelayReqInterval;
+  TimeInternal peerMeanPathDelay;
 
+  /*Configurable members*/
+  Integer8 logAnnounceInterval;
+  UInteger8 announceReceiptTimeout;
+  Integer8 logSyncInterval;
+  Enumeration8 delayMechanism;
+  Integer8 logMinPdelayReqInterval;
+  UInteger4 versionNumber;
 
-	/* Foreign master data set */
-	ForeignMasterRecord *foreign;
 
-	/* Other things we need for the protocol */
-	UInteger16 number_foreign_records;
-	Integer16  max_foreign_records;
-	Integer16  foreign_record_i;
-	Integer16  foreign_record_best;
-	UInteger32 random_seed;
-	Boolean  record_update;    /* should we run bmc() after receiving an announce message? */
+  /* Foreign master data set */
+  ForeignMasterRecord *foreign;
 
+  /* Other things we need for the protocol */
+  UInteger16 number_foreign_records;
+  Integer16  max_foreign_records;
+  Integer16  foreign_record_i;
+  Integer16  foreign_record_best;
+  UInteger32 random_seed;
+  Boolean  record_update;    /* should we run bmc() after receiving an announce message? */
 
-	MsgHeader msgTmpHeader;
 
-	union {
-		MsgSync  sync;
-		MsgFollowUp  follow;
-		MsgDelayReq  req;
-		MsgDelayResp resp;
-		MsgPDelayReq  preq;
-		MsgPDelayResp  presp;
-		MsgPDelayRespFollowUp  prespfollow;
-		MsgManagement  manage;
-		MsgAnnounce  announce;
-		MsgSignaling signaling;
-	} msgTmp;
+  MsgHeader msgTmpHeader;
 
+  union {
+    MsgSync  sync;
+    MsgFollowUp  follow;
+    MsgDelayReq  req;
+    MsgDelayResp resp;
+    MsgPDelayReq  preq;
+    MsgPDelayResp  presp;
+    MsgPDelayRespFollowUp  prespfollow;
+    MsgManagement  manage;
+    MsgAnnounce  announce;
+    MsgSignaling signaling;
+  } msgTmp;
 
-	Octet msgObuf[PACKET_SIZE];
-	Octet msgIbuf[PACKET_SIZE];
 
-/*
-	20110630: These variables were deprecated in favor of the ones that appear in the stats log (delayMS and delaySM)
-	
-	TimeInternal  master_to_slave_delay;
-	TimeInternal  slave_to_master_delay;
+  Octet msgObuf[PACKET_SIZE];
+  Octet msgIbuf[PACKET_SIZE];
 
-	*/
-	Integer32 	observed_drift;
+  TimeInternal  master_to_slave_delay;
+  TimeInternal  slave_to_master_delay;
+  LongDouble    observed_drift;
+  LongDouble    frequency_adjustment;
 
-	TimeInternal  pdelay_req_receive_time;
-	TimeInternal  pdelay_req_send_time;
-	TimeInternal  pdelay_resp_receive_time;
-	TimeInternal  pdelay_resp_send_time;
-	TimeInternal  sync_receive_time;
-	TimeInternal  delay_req_send_time;
-	TimeInternal  delay_req_receive_time;
-	MsgHeader		PdelayReqHeader;
-	MsgHeader		delayReqHeader;
-	TimeInternal	pdelayMS;
-	TimeInternal	pdelaySM;
-	TimeInternal  delayMS;
-	TimeInternal	delaySM;
-	TimeInternal  lastSyncCorrectionField;
-	TimeInternal  lastPdelayRespCorrectionField;
+  TimeInternal  pdelay_req_receive_time;
+  TimeInternal  pdelay_req_send_time;
+  TimeInternal  pdelay_resp_receive_time;
+  TimeInternal  pdelay_resp_send_time;
+  TimeInternal  sync_receive_time;
+  TimeInternal  delay_req_send_time;
+  TimeInternal  delay_req_receive_time;
+  MsgHeader		PdelayReqHeader;
+  MsgHeader		delayReqHeader;
+  TimeInternal	pdelayMS;
+  TimeInternal	pdelaySM;
+  TimeInternal  delayMS;
+  TimeInternal	delaySM;
+  TimeInternal  lastSyncCorrectionField;
+  TimeInternal  lastPdelayRespCorrectionField;
 
+  /**
+  * TRUE when the clock is used to synchronize NIC and system time and
+  * the process is the PTP_MASTER. The offset and adjustment calculation
+  * is always "master (= NIC) to slave (= system time)" and PTP_SLAVEs
+  * update their system time, but the master needs to invert the
+  * clock adjustment and control NIC time instead. This way
+  * the master's system time is propagated to slaves.
+  */
+  Boolean nic_instead_of_system;
 
+  /**
+  * Specifies the method for retrieving timestamps. Depending on the kernel
+  * version and operating mode, timestamping is done by either system
+  * timestamps made by the kernel,
+  * queue, the socket error queue or via proprietary ioctl operations.
+  */
+  TsMethod tsMethod;
 
-	Boolean  sentPDelayReq;
-	UInteger16  sentPDelayReqSequenceId;
-	UInteger16  sentDelayReqSequenceId;
-	UInteger16  sentSyncSequenceId;
-	UInteger16  sentAnnounceSequenceId;
-	UInteger16  recvPDelayReqSequenceId;
-	UInteger16  recvSyncSequenceId;
-	UInteger16  recvPDelayRespSequenceId;
-	Boolean  waitingForFollow;
-	Boolean  waitingForDelayResp;
-	
+  /**
+  * a prefix to be inserted before messages about the clock:
+  * may be empty, but not NULL
+  *
+  * used to distinguish multiple active clock servos per process
+  */
+  const char *name;
 
-	offset_from_master_filter  ofm_filt;
-	one_way_delay_filter  owd_filt;
+  Boolean  sentPDelayReq;
+  UInteger16  sentPDelayReqSequenceId;
+  UInteger16  sentDelayReqSequenceId;
+  UInteger16  sentSyncSequenceId;
+  UInteger16  sentAnnounceSequenceId;
+  UInteger16  recvPDelayReqSequenceId;
+  UInteger16  recvSyncSequenceId;
+  UInteger16  recvPDelayRespSequenceId;
+  Boolean  waitingForFollow;
+  Boolean  waitingForDelayResp;
 
-	Boolean message_activity;
 
-	IntervalTimer  itimer[TIMER_ARRAY_SIZE];
+  offset_from_master_filter  ofm_filt;
+  one_way_delay_filter  owd_filt;
 
-	NetPath netPath;
+  Boolean message_activity;
 
-	/*Usefull to init network stuff*/
-	UInteger8 port_communication_technology;
-	Octet port_uuid_field[PTP_UUID_LENGTH];
+  IntervalTimer  itimer[TIMER_ARRAY_SIZE];
 
-	int reset_count;
-	int current_init_clock;
-	int can_step_clock;
-	int warned_operator_slow_slewing;
-	int warned_operator_fast_slewing;
+  NetPath netPath;
 
-	char char_last_msg;                             /* representation of last message processed by servo */
-	Boolean last_packet_was_sync;                   /* used to limit logging of Sync messages */
-	
-	int waiting_for_first_sync;                     /* we'll only start the delayReq timer after the first sync */
-	int waiting_for_first_delayresp;                /* Just for information purposes */
-	Boolean startup_in_progress;
-	
-#ifdef PTP_EXPERIMENTAL
-	Integer32 MasterAddr;                           // used for hybrid mode, when receiving announces
-	Integer32 LastSlaveAddr;                        // used for hybrid mode, when receiving delayreqs
-#endif
+  /*Usefull to init network stuff*/
+  UInteger8 port_communication_technology;
+  Octet port_uuid_field[PTP_UUID_LENGTH];
 
+  int reset_count;
+  int warned_operator_slow_slewing;
+  int warned_operator_fast_slewing;
+
+  char char_last_msg;  					/* representation of last message processed by servo */
+  Boolean last_packet_was_sync;                   /* used to limit logging of Sync messages */
+
+  int waiting_for_first_sync;				/* we'll only start the delayReq timer after the first sync */
+  int waiting_for_first_delayresp;		/* Just for information purposes */
+
+  Boolean offset_first_updated;
+  Boolean clock_first_updated;
+
+  Statistics statistics;
+  
 } PtpClock;
 
 /**
- * \struct RunTimeOpts
- * \brief Program options set at run-time
- */
+* \enum Time mode enumeration
+* \brief Time mode for PTP clock
+*/
+typedef enum {
+  /**
+  * Use and control system time
+  */
+  TIME_SYSTEM,
+  /**
+  * Use and control network interface time using Solarflare IOCTLs and
+  * net_tstamp.h API.
+  */
+  TIME_NIC,
+  /**
+  * A combination of PTP between NICs plus a local synchronization
+  * between NIC and system time:
+  *
+  * - NIC time is controlled via PTP packets, main time seen
+  *   by PTPd is the NIC time
+  * - system_to_nic and nic_to_system delays are provided by
+  *   device driver on request
+  * - time.c adapts NIC time to system time on master and system time
+  *   to NIC time on slaves by feeding these offsets into another
+  *   instance of the clock servo (as in TIME_SYSTEM)
+  *
+  * The command line options only apply to one clock sync and
+  * the defaults are used for the other:
+  * - NIC time: default values for clock control (adjust and reset)
+  *   and servo (coefficients), configurable PTP
+  * - system time: configurable clock control and servo, PTP options do
+  *   not apply
+  */
+  TIME_BOTH,
+  /**
+  * Time used and controlled by PTP is the system time with hardware
+  * packet time stamping via Linux net_tstamp.h API or using driver
+  * proprietary IOCTLs.
+  */
+  TIME_SYSTEM_LINUX_HW,
+  /**
+  * Time used and controlled by PTP is the system time with software
+  * packet time stamping via standard Linux net_tstamp.h API.
+  */
+  TIME_SYSTEM_LINUX_SW,
+
+  TIME_MAX
+} TimeMode;
+
+/**
+* \enum Master slave mode enumeration
+* \brief Master/slave mode for PTP clock
+*/
+typedef enum {
+  PTP_MODE_NULL,
+  PTP_MODE_MASTER_NO_NTP,
+  PTP_MODE_MASTER_WITH_NTP,
+  PTP_MODE_SLAVE
+} MasterSlaveMode;
+
+/**
+* \struct RunTimeOpts
+* \brief Program options set at run-time
+*/
 /* program options set at run-time */
 typedef struct {
-	Integer8 announceInterval;
-	Integer8 announceReceiptTimeout;
-	
-	Integer8 syncInterval;
-	ClockQuality clockQuality;
-	UInteger8 priority1;
-	UInteger8 priority2;
-	UInteger8 domainNumber;
+  LongDouble announceInterval;
+  Integer8 announceReceiptTimeout;
+
+  LongDouble syncInterval;
+  ClockQuality clockQuality;
+  UInteger8 priority1;
+  UInteger8 priority2;
+  UInteger8 domainNumber;
 #ifdef PTP_EXPERIMENTAL
 	UInteger8 mcast_group_Number;
 #endif
 
 	Boolean	slaveOnly;
-	Integer16 currentUtcOffset;
-	Octet ifaceName[IFACE_NAME_LENGTH];
-	Boolean	noResetClock;
-	Integer32 maxReset; /* Maximum number of nanoseconds to reset */
-	Integer32 maxDelay; /* Maximum number of nanoseconds of delay */
-	Boolean	noAdjust;
-	Boolean	displayStats;
-	Boolean	csvStats;
-	Boolean displayPackets;
-	Octet unicastAddress[MAXHOSTNAMELEN];
-	Integer32 ap, ai;
-	Integer16 s;
-	TimeInternal inboundLatency, outboundLatency;
-	Integer16 max_foreign_records;
-	Boolean ethernet_mode;
-	Enumeration8 delayMechanism;
-	Boolean	offset_first_updated;
-	char file[PATH_MAX];
-	int logFd;
-	Boolean useSysLog;
-	int ttl;
-	char recordFile[PATH_MAX];
-	FILE *recordFP;
+  Integer16 currentUtcOffset;
+  Boolean currentUtcOffsetValid;
+  Octet ifaceName[IFACE_NAME_LENGTH];
+  Boolean	noResetClock;
+  Boolean resetClockStartupOnly;
+  Integer32 maxReset; /* Maximum number of nanoseconds to reset */
+  TimeInternal maxDelay; /* Maximum number of nanoseconds of delay */
+  Boolean	noAdjust;
+  Boolean	displayStats;
+  Boolean verboseStats;
+  Boolean	csvStats;
+  Boolean displayPackets;
+  Octet unicastAddress[MAXHOSTNAMELEN];
+  Integer32 ap, ai;
+  Integer16 s;
+  TimeInternal inboundLatency, outboundLatency;
+  Integer16 max_foreign_records;
+  Boolean ethernet_mode;
+  Enumeration8 delayMechanism;
+//  Boolean	offset_first_updated;
+  char file[PATH_MAX];
+  int logFd;
+  Boolean useSysLog;
+#ifndef __sun
+  int ttl;
+#else 
+  uchar_t ttl;
+#endif
+  char recordFile[PATH_MAX];
+  FILE *recordFP;
 
-	int log_seconds_between_message;
+  int log_seconds_between_message;
 
-	Boolean ignore_daemon_lock;
-	Boolean do_IGMP_refresh;
-	int nonDaemon;
-	Boolean do_log_to_file;
-	Boolean do_record_quality_file;
-	
-	int initial_delayreq;
-	int subsequent_delayreq;
+  Boolean ignore_daemon_lock;
+  Boolean do_IGMP_refresh;
+  int nonDaemon;
+  Boolean do_log_to_file;
+  Boolean do_record_quality_file;
+
+  LongDouble initial_delayreq;
+  int subsequent_delayreq;
 	Boolean ignore_delayreq_interval_master;
-	Boolean syslog_startup_messages_also_to_stdout;
-	
+  Boolean syslog_startup_messages_also_to_stdout;
+
 #ifdef PTP_EXPERIMENTAL
 	int do_hybrid_mode;
 #endif
-	int do_unicast_mode;
-
-#ifdef RUNTIME_DEBUG
-	int debug_level;
-#endif
+  TimeMode time_mode;
+  MasterSlaveMode master_slave_mode;
+  LongDouble system_time_update_interval;
+  int do_unicast_mode;
+  
+  int debug_level;
 
 } RunTimeOpts;
 
diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/constants_dep.h
--- a/src/dep/constants_dep.h	Tue May 14 17:07:59 2013 -0700
+++ b/src/dep/constants_dep.h	Sun Oct 27 22:49:29 2013 -0700
@@ -1,3 +1,33 @@
+/*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
+ * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
+ *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
+ * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
+ *
+ * All Rights Reserved
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are
+ * met:
+ * 1. Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
+ * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+ * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
+ * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
+ * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
 
 /* constants_dep.h */
 
@@ -16,7 +46,7 @@
 /* platform dependent */
 
 #if !defined(linux) && !defined(__NetBSD__) && !defined(__FreeBSD__) && \
-  !defined(__APPLE__)
+  !defined(__APPLE__) && !defined(__sun)
 #error Not ported to this architecture, please update.
 #endif
 
@@ -38,7 +68,7 @@
 #endif /* linux */
 
 
-#if defined(__NetBSD__) || defined(__FreeBSD__) || defined(__APPLE__)
+#if defined(__NetBSD__) || defined(__FreeBSD__) || defined(__APPLE__) || defined(__sun)
 # include <sys/types.h>
 # include <sys/socket.h>
 # include <netinet/in.h>
@@ -48,6 +78,9 @@
 # if defined(__FreeBSD__) || defined(__APPLE__)
 #  include <net/ethernet.h>
 #  include <sys/uio.h>
+# elif defined(__sun)
+#  include <sys/ethernet.h>
+#  include <sys/uio.h>
 # else
 #  include <net/if_ether.h>
 # endif
@@ -55,25 +88,35 @@
 # define IFACE_NAME_LENGTH         IF_NAMESIZE
 # define NET_ADDRESS_LENGTH        INET_ADDRSTRLEN
 
-# define IFCONF_LENGTH 10
+# define IFCONF_LENGTH 20
 
 # define adjtimex ntp_adjtime
 
+#if !defined(__sun)
 # include <machine/endian.h>
 # if BYTE_ORDER == LITTLE_ENDIAN
 #   define PTPD_LSBF
 # elif BYTE_ORDER == BIG_ENDIAN
 #   define PTPD_MSBF
 # endif
+#else
+# if defined(__sparc__)
+#   define PTPD_MSBF
+# else
+#   define PTPD_LSBF
+# endif
+#endif
 #endif
 
+#define SFC_FIRMWARE_VERSION_NUMBER_MIN 6039
+
 #define CLOCK_IDENTITY_LENGTH 8
-#define ADJ_FREQ_MAX  512000
+/* The system clock can handle frequency adjustments up to 100,000,000ppb */
+#define ADJ_FREQ_MAX_SYSTEM  100000000.0
+/* Our NIC can only handle frequency adjustments up to 1,000,000ppb */
+#define ADJ_FREQ_MAX_NIC  1000000.0
 
 /* UDP/IPv4 dependent */
-#ifndef INADDR_LOOPBACK
-#define INADDR_LOOPBACK 0x7f000001UL
-#endif
 
 #define SUBDOMAIN_ADDRESS_LENGTH  4
 #define PORT_ADDRESS_LENGTH       2
@@ -110,6 +153,8 @@
 
 #define NANOSECONDS_MAX 999999999
 
+/* our own errno for failure to retrieve timestamp */
+#define ENOTIMESTAMP  1000
 
 // limit operator messages to once every X seconds
 #define OPERATOR_MESSAGES_INTERVAL 300.0
diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/datatypes_dep.h
--- a/src/dep/datatypes_dep.h	Tue May 14 17:07:59 2013 -0700
+++ b/src/dep/datatypes_dep.h	Sun Oct 27 22:49:29 2013 -0700
@@ -1,12 +1,44 @@
+/*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
+ * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
+ *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
+ * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
+ *
+ * All Rights Reserved
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are
+ * met:
+ * 1. Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
+ * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+ * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
+ * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
+ * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
 #ifndef DATATYPES_DEP_H_
 #define DATATYPES_DEP_H_
 
+#include <sys/ioctl.h>
+#include <net/if.h>
+
 /**
 *\file
 * \brief Implementation specific datatype
 
  */
-/* FIXME: shouldn't uint32_t and friends be used here? */
 typedef enum {FALSE=0, TRUE} Boolean;
 typedef char Octet;
 typedef signed char Integer8;
@@ -20,12 +52,13 @@
 typedef unsigned char Enumeration4;
 typedef unsigned char UInteger4;
 typedef unsigned char Nibble;
+typedef long double LongDouble;
 
 /**
 * \brief Implementation specific of UInteger48 type
  */
 typedef struct {
-	unsigned int lsb;     /* FIXME: shouldn't uint32_t and uint16_t be used here? */
+	unsigned int lsb;
 	unsigned short msb;
 } UInteger48;
 
@@ -33,7 +66,7 @@
 * \brief Implementation specific of Integer64 type
  */
 typedef struct {
-	unsigned int lsb;     /* FIXME: shouldn't uint32_t and int32_t be used here? */
+	unsigned int lsb;
 	int msb;
 } Integer64;
 
@@ -58,20 +91,48 @@
   Integer32  s_exp;
 } one_way_delay_filter;
 
+
+#define TX_STACK_SIZE 1
+
+/**
+* \brief Time structure to handle Linux time information
+ */
+typedef struct TimeInternal {
+  Integer32 seconds;
+  Integer32 nanoseconds;
+} TimeInternal;
+
+
+struct tx_item {
+  int len;
+  TimeInternal ts;
+  unsigned char buf[PACKET_SIZE];
+};
+
 /**
 * \brief Struct used to store network datas
  */
 typedef struct {
   Integer32 eventSock, generalSock, multicastAddr, peerMulticastAddr,unicastAddr;
 
+#if defined(linux) 
+  /** for further ioctl() calls on eventSock */
+  struct ifreq eventSockIFR;
+#elif defined(__sun)
+  Integer32 devFd;
+  struct lifreq eventSockIFR;
+  void	*ioctl_req;
+#endif
+
+
+  /* @ioctl_timestamping Added support for hw based timestamping */
+  struct {
+    struct tx_item data[TX_STACK_SIZE];
+    int count;
+  } tx_stack;
+
   /* used by IGMP refresh */
   struct in_addr interfaceAddr;
-
-#ifdef PTP_EXPERIMENTAL
-  /* used for Hybrid mode */
-  Integer32 lastRecvAddr;
-#endif
-
 } NetPath;
 
 #endif /*DATATYPES_DEP_H_*/
